## onnxruntime 1.23.2%2Bdfsg

=== tools/ci_build/requirements/transformers-test/requirements.txt ===
# packages used by transformers python unittest
packaging
# protobuf and numpy is same as tools/ci_build/github/linux/docker/scripts/manylinux/requirements.txt
protobuf==4.25.1
numpy==2.2.6
torch==2.8.0
torchvision==0.23.0
coloredlogs==15.0
transformers==4.52.1
parameterized>=0.8.1
sentencepiece
psutil
einops
onnxscript==0.5.3
onnx-ir==0.1.10

=== tools/ci_build/github/linux/docker/scripts/lort/requirements.txt ===
transformers
beartype==0.15.0
flatbuffers
cerberus
h5py
onnx==1.18.0
# Python dependencies required for pytorch development
astunparse
expecttest!=0.2.0
hypothesis
numpy==2.2.6
psutil
pyyaml
requests
setuptools
types-dataclasses
typing-extensions>=4.8.0
sympy
filelock
networkx
jinja2
fsspec
lintrunner
# setuptools was removed from default python install
setuptools ; python_version >= "3.12"
packaging
optree>=0.11.0

=== debian/control ===
Source: onnxruntime
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Dylan Aïssi <daissi@debian.org>,
           Shengqi Chen <harry@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-sequence-python3,
               dh-sequence-numpy3,
               cmake,
               libboost-dev,
#               libbenchmark-dev, # not enabled in rules
               libcpuinfo-dev (>= 0.0~git20240830.fa1c679),
               libdlpack-dev,
               libeigen3-dev (>= 3.4.0),
               libflatbuffers-dev,
#               libgmock-dev <!nocheck>,
#               libgtest-dev <!nocheck>,
               libhowardhinnant-date-dev,
               libmsgsl-dev,
               libonnx-dev (>= 1.20.0),
#               libonnx-testdata <!nocheck>,
               libpng-dev,
               libprotobuf-dev,
               libpthreadpool-dev,
               libsafeint-dev,
               libre2-dev,
               libdnnl-dev [amd64 arm64 ppc64el s390x],
               libxnnpack-dev (>= 0.0~git20241108.4ea82e5~) [amd64 arm64 armhf i386 riscv64 x32],
               ninja-build,
               nlohmann-json3-dev,
               protobuf-compiler,
               pkgconf,
               python3,
               python3-dev,
               python3-numpy,
               python3-onnx,
               python3-packaging,
               python3-protobuf,
               python3-pybind11,
               python3-setuptools,
               python3-wheel,
               sse2-support [i386],
               zlib1g-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/deeplearning-team/onnxruntime
Vcs-Git: https://salsa.debian.org/deeplearning-team/onnxruntime.git
Homepage: https://github.com/microsoft/onnxruntime
Rules-Requires-Root: no

Package: libonnxruntime1.23
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libonnxruntime-providers (= ${binary:Version}),
         sse2-support [i386]
Conflicts: libonnxruntime1.19.2, libonnxruntime1.20.1
Replaces: libonnxruntime1.19.2, libonnxruntime1.20.1,
          libonnxruntime-dev (<< 1.20.1+dfsg-1~exp2~)
Breaks: libonnxruntime-dev (<< 1.20.1+dfsg-1~exp2~)
Description: cross-platform inference and training ML accelerator (shared lib)
 ONNX Runtime is a performance-focused complete scoring engine for Open Neural
 Network Exchange (ONNX) models, with an open extensible architecture to
 continually address the latest developments in AI and Deep Learning. ONNX
 Runtime stays up to date with the ONNX standard with complete implementation of
 all ONNX operators, and supports all ONNX releases (1.2+) with both future and
 backwards compatibility. Please refer to this page for ONNX opset compatibility
 details.
 .
 This package provides the shared library.

Package: libonnxruntime-providers
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         sse2-support [i386]
Breaks: libonnxruntime1.21 (<< 1.21.0+dfsg-2~)
Replaces: libonnxruntime1.21 (<< 1.21.0+dfsg-2~)
Description: cross-platform inference and training ML accelerator (providers)
 ONNX Runtime is a performance-focused complete scoring engine for Open Neural
 Network Exchange (ONNX) models, with an open extensible architecture to
 continually address the latest developments in AI and Deep Learning. ONNX
 Runtime stays up to date with the ONNX standard with complete implementation of
 all ONNX operators, and supports all ONNX releases (1.2+) with both future and
 backwards compatibility. Please refer to this page for ONNX opset compatibility
 details.
 .
 This package provides the providers.

Package: libonnxruntime-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libonnxruntime1.23 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libonnxruntime1.13.1 (<< 1.16.3+dfsg-1~)
Replaces: libonnxruntime1.13.1 (<< 1.16.3+dfsg-1~)
Description: cross-platform inference and training ML accelerator (dev files)
 ONNX Runtime is a performance-focused complete scoring engine for Open Neural
 Network Exchange (ONNX) models, with an open extensible architecture to
 continually address the latest developments in AI and Deep Learning. ONNX
 Runtime stays up to date with the ONNX standard with complete implementation of
 all ONNX operators, and supports all ONNX releases (1.2+) with both future and
 backwards compatibility. Please refer to this page for ONNX opset compatibility
 details.
 .
 This package provides the development files for libonnxruntime.

Package: onnxruntime-tools
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: cross-platform inference and training ML accelerator (tools)
 ONNX Runtime is a performance-focused complete scoring engine for Open Neural
 Network Exchange (ONNX) models, with an open extensible architecture to
 continually address the latest developments in AI and Deep Learning. ONNX
 Runtime stays up to date with the ONNX standard with complete implementation of
 all ONNX operators, and supports all ONNX releases (1.2+) with both future and
 backwards compatibility. Please refer to this page for ONNX opset compatibility
 details.
 .
 This package provides the onnxruntime tools.

Package: python3-onnxruntime
Architecture: any
Section: python
Depends: libonnxruntime1.23 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         sse2-support [i386]
Description: cross-platform inference and training ML accelerator (Python bindings)
 ONNX Runtime is a performance-focused complete scoring engine for Open Neural
 Network Exchange (ONNX) models, with an open extensible architecture to
 continually address the latest developments in AI and Deep Learning. ONNX
 Runtime stays up to date with the ONNX standard with complete implementation of
 all ONNX operators, and supports all ONNX releases (1.2+) with both future and
 backwards compatibility. Please refer to this page for ONNX opset compatibility
 details.
 .
 This package provides the onnxruntime Python bindings.

## onnxruntime 1.23.2+dfsg

=== cmake/CMakeLists.txt ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# SPDX-FileCopyrightText: Copyright 2024 Arm Limited and/or its affiliates <open-source-office@arm.com>
# Licensed under the MIT License.

# Minimum CMake required
cmake_minimum_required(VERSION 3.28)

# Don't let cmake set a default value for CMAKE_CUDA_ARCHITECTURES
cmake_policy(SET CMP0104 OLD)
# Project
project(onnxruntime C CXX ASM)

# Disable fast-math for Intel oneAPI compiler
if("${CMAKE_CXX_COMPILER_ID}" MATCHES "IntelLLVM")
  if("${CMAKE_CXX_COMPILER_ID}" MATCHES "MSVC-like")
    # Using icx-cl compiler driver with MSVC-like arguments
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fp:precise")
  else()
    # Using icpx compiler driver
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-fast-math")
  endif()
endif()

# Needed for Java
set(CMAKE_C_STANDARD 99)

include(CheckCXXCompilerFlag)
include(CheckLanguage)
include(CMakeDependentOption)
include(FetchContent)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(GNUInstallDirs) # onnxruntime_providers_* require CMAKE_INSTALL_* variables

# TODO: update this once all system adapt c++20
if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
set(CMAKE_CXX_STANDARD 20)
else()
set(CMAKE_CXX_STANDARD 17)
endif()

if (MSVC)
  #  Make sure Visual Studio sets __cplusplus macro correctly: https://learn.microsoft.com/en-us/cpp/build/reference/zc-cplusplus
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
# NOTE: POSITION INDEPENDENT CODE hurts performance, and it only make sense on POSIX systems
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

enable_testing()
if (NOT CMAKE_BUILD_TYPE)
  message(STATUS "Build type not set - using RelWithDebInfo")
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose build type: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# Options
option(onnxruntime_USE_VCPKG "Build with the vcpkg package manager" OFF)
option(onnxruntime_RUN_ONNX_TESTS "Enable ONNX Compatibility Testing" OFF)
option(onnxruntime_GENERATE_TEST_REPORTS "Enable test report generation" OFF)
option(onnxruntime_ENABLE_STATIC_ANALYSIS "Enable static analysis" OFF)
option(onnxruntime_USE_CUSTOM_STATIC_ANALYSIS_RULES "Use a custom SDL Rule. It is mainly for our CI build" OFF)
option(onnxruntime_REDIRECT_STATIC_ANALYSIS_OUTPUTS_TO_FILE "Use a custom SDL Rule. It is mainly for our CI build" OFF)
option(onnxruntime_ENABLE_PYTHON "Enable python bindings" OFF)
# Enable it may cause LNK1169 error
option(onnxruntime_ENABLE_MEMLEAK_CHECKER "Experimental: Enable memory leak checker in Windows debug build" OFF)
option(onnxruntime_ENABLE_CONVSYMKERNELAVX2_SAT_CHECKER "Experimental: Enable ConvSymKernelAvx2 assembly saturation checker in build" OFF)
option(onnxruntime_USE_CUDA "Build with CUDA support" OFF)
# Enable ONNX Runtime CUDA EP's internal unit tests that directly access the EP's internal functions instead of through
# OpKernels. When the option is ON, we will have two copies of GTest library in the same process. It is not a typical
# use. If you hit any problem with that, please do not report it to GTest. Turn OFF the following build option instead.
cmake_dependent_option(onnxruntime_ENABLE_CUDA_EP_INTERNAL_TESTS "Build with CUDA unit tests" OFF "onnxruntime_USE_CUDA;onnxruntime_BUILD_UNIT_TESTS" OFF)

cmake_dependent_option(onnxruntime_USE_CUDA_NHWC_OPS "Build CUDA with NHWC op support" ON "onnxruntime_USE_CUDA" OFF)
option(onnxruntime_CUDA_MINIMAL "Build CUDA without any operations apart from memcpy ops. Usefuel for a very minial TRT build" OFF)
option(onnxruntime_ENABLE_CUDA_LINE_NUMBER_INFO "When building with CUDA support, generate device code line number information." OFF)
option(onnxruntime_USE_OPENVINO "Build with OpenVINO support" OFF)
option(onnxruntime_USE_COREML "Build with CoreML support" OFF)
option(onnxruntime_USE_NNAPI_BUILTIN "Build with builtin NNAPI lib for Android NNAPI support" OFF)
option(onnxruntime_USE_QNN "Build with QNN support" OFF)
option(onnxruntime_BUILD_QNN_EP_STATIC_LIB "Build with QNN EP as a static library" OFF)
option(onnxruntime_USE_SNPE "Build with SNPE support" OFF)
option(onnxruntime_USE_RKNPU "Build with RKNPU support" OFF)
option(onnxruntime_USE_DNNL "Build with DNNL support" OFF)
option(onnxruntime_USE_JSEP "Build with JavaScript implemented kernels support" OFF)
option(onnxruntime_USE_KLEIDIAI "Build with KleidiAI integration in MLAS" OFF)
# iOS simulator build explicitly builds targets with USE_KLEIDIAI=ON so attempting to force override if so
if(APPLE AND CMAKE_OSX_ARCHITECTURES MATCHES "x86_64")
    message(WARNING "Disabling KleidiAI: not supported on Apple x86_64 platforms")
  set(onnxruntime_USE_KLEIDIAI OFF CACHE BOOL "" FORCE)
endif()
option(onnxruntime_BUILD_UNIT_TESTS "Build ONNXRuntime unit tests" ON)
option(onnxruntime_BUILD_CSHARP "Build C# library" OFF)
option(onnxruntime_BUILD_OBJC "Build Objective-C library" OFF)
option(onnxruntime_USE_PREINSTALLED_EIGEN "Use pre-installed EIGEN. Need to provide eigen_SOURCE_PATH if turn this on." OFF)
option(onnxruntime_BUILD_BENCHMARKS "Build ONNXRuntime micro-benchmarks" OFF)
option(onnxruntime_USE_VSINPU "Build with VSINPU support" OFF)

cmake_dependent_option(onnxruntime_USE_FLASH_ATTENTION "Build flash attention kernel for scaled dot product attention" ON "onnxruntime_USE_CUDA" OFF)
option(onnxruntime_USE_LEAN_ATTENTION "Build lean attention kernel for scaled dot product attention" OFF)
cmake_dependent_option(onnxruntime_USE_MEMORY_EFFICIENT_ATTENTION "Build memory efficient attention kernel for scaled dot product attention" ON "onnxruntime_USE_CUDA" OFF)
option(onnxruntime_USE_FPA_INTB_GEMM "Build FpA IntB gemm cuda kernels" OFF)

option(onnxruntime_BUILD_FOR_NATIVE_MACHINE "Enable this option for turning on optimization specific to this machine" OFF)
option(onnxruntime_USE_AVX "Use AVX instructions" OFF)
option(onnxruntime_USE_AVX2 "Use AVX2 instructions" OFF)
option(onnxruntime_USE_AVX512 "Use AVX512 instructions" OFF)

option(onnxruntime_BUILD_SHARED_LIB "Build a shared library" OFF)
option(onnxruntime_BUILD_APPLE_FRAMEWORK "Build a macOS/iOS framework" OFF)
option(onnxruntime_ENABLE_MICROSOFT_INTERNAL "Use this option to enable/disable microsoft internal only code" OFF)

option(onnxruntime_USE_VITISAI "Build with Vitis-AI" OFF)
option(onnxruntime_USE_TENSORRT "Build with TensorRT support" OFF)
option(onnxruntime_USE_TENSORRT_BUILTIN_PARSER "Use TensorRT builtin parser" OFF)
option(onnxruntime_USE_NV "Build with TensorRT support" OFF)
option(onnxruntime_ENABLE_LTO "Enable link time optimization" OFF)
option(onnxruntime_CROSS_COMPILING "Cross compiling onnx runtime" OFF)
option(onnxruntime_GCOV_COVERAGE "Compile with options necessary to run code coverage" OFF)
option(onnxruntime_DONT_VECTORIZE "Do not vectorize operations in Eigen" OFF)

option(onnxruntime_USE_FULL_PROTOBUF "Link to libprotobuf instead of libprotobuf-lite when this option is ON" OFF)
option(onnxruntime_DEBUG_NODE_INPUTS_OUTPUTS "Dump debug information about node inputs and outputs when executing the model." OFF)
cmake_dependent_option(onnxruntime_DEBUG_NODE_INPUTS_OUTPUTS_ENABLE_DUMP_TO_SQLDB "Build dump debug information about node inputs and outputs with support for sql database." OFF "onnxruntime_DEBUG_NODE_INPUTS_OUTPUTS" OFF)

# When loading a delay loaded DLL, Windows searches the main EXE's folder first.
cmake_dependent_option(onnxruntime_ENABLE_DELAY_LOADING_WIN_DLLS "Delay load some of the dependent DLls that are part of the OS" ON "WIN32;NOT GDK_PLATFORM" OFF)
option(onnxruntime_USE_DML "Build with DirectML support" OFF)
option(onnxruntime_USE_MIGRAPHX "Build with AMDMIGraphX support" OFF)
option(onnxruntime_USE_WINML "Build with WinML support" OFF)
option(onnxruntime_USE_ACL "Build with ACL support" OFF)
option(onnxruntime_USE_ARMNN "Build with ArmNN support" OFF)
option(onnxruntime_ARMNN_RELU_USE_CPU "Use the CPU implementation for the Relu operator for the ArmNN EP" ON)
option(onnxruntime_ARMNN_BN_USE_CPU "Use the CPU implementation for the Batch Normalization operator for the ArmNN EP" ON)
option(onnxruntime_ENABLE_INSTRUMENT "Enable Instrument with Event Tracing for Windows (ETW)" OFF)
option(onnxruntime_USE_TELEMETRY "Build with Telemetry" OFF)
cmake_dependent_option(onnxruntime_USE_MIMALLOC "Override new/delete and arena allocator with mimalloc" OFF "WIN32;NOT onnxruntime_USE_CUDA;NOT onnxruntime_USE_OPENVINO" OFF)
option(onnxruntime_USE_CANN "Build with CANN support" OFF)
option(onnxruntime_USE_XNNPACK "Build with XNNPACK support. Provides an alternative math library on ARM, WebAssembly and x86." OFF)
option(onnxruntime_USE_WEBNN "Build with WebNN support. Enable hardware acceleration in web browsers." OFF)
option(onnxruntime_USE_WEBGPU "Build with WebGPU support. Enable WebGPU via C/C++ interface." OFF)
option(onnxruntime_WGSL_TEMPLATE "Specify the code generator for WGSL template. Default is static." "static")
option(onnxruntime_USE_EXTERNAL_DAWN "Build with treating Dawn as external dependency. Will not link Dawn at build time." OFF)
option(onnxruntime_CUSTOM_DAWN_SRC_PATH "Path to custom Dawn src dir.")
option(onnxruntime_BUILD_DAWN_MONOLITHIC_LIBRARY "Build Dawn as a monolithic library" OFF)
option(onnxruntime_ENABLE_PIX_FOR_WEBGPU_EP "Adding frame present for PIX to capture a frame" OFF)
# The following 2 options are only for Windows
option(onnxruntime_ENABLE_DAWN_BACKEND_VULKAN "Enable Vulkan backend for Dawn (on Windows)" OFF)
option(onnxruntime_ENABLE_DAWN_BACKEND_D3D12 "Enable D3D12 backend for Dawn (on Windows)" ON)

# Options related to reducing the binary size produced by the build
# XNNPACK EP requires the internal NHWC contrib ops to be available, so this option must be OFF when onnxruntime_USE_XNNPACK is ON
cmake_dependent_option(onnxruntime_DISABLE_CONTRIB_OPS "Disable contrib ops" OFF "NOT onnxruntime_USE_XNNPACK" OFF)
option(onnxruntime_DISABLE_ML_OPS "Disable traditional ML ops" OFF)
option(onnxruntime_DISABLE_SPARSE_TENSORS "Disable sparse tensors data types" OFF)
option(onnxruntime_DISABLE_OPTIONAL_TYPE "Disable optional type" OFF)
option(onnxruntime_DISABLE_FLOAT8_TYPES "Disable float 8 types" OFF)
option(onnxruntime_MINIMAL_BUILD "Exclude as much as possible from the build. Support ORT format models. No support for ONNX format models." OFF)
option(onnxruntime_CLIENT_PACKAGE_BUILD "Enables default settings that are more appropriate for client/on-device workloads." OFF)
cmake_dependent_option(onnxruntime_DISABLE_RTTI "Disable RTTI" ON "NOT onnxruntime_ENABLE_PYTHON;NOT onnxruntime_USE_CUDA" OFF)
# For now onnxruntime_DISABLE_EXCEPTIONS will only work with onnxruntime_MINIMAL_BUILD, more changes (ONNX, non-CPU EP, ...) are required to run this standalone
cmake_dependent_option(onnxruntime_DISABLE_EXCEPTIONS "Disable exception handling. Requires onnxruntime_MINIMAL_BUILD currently." ON "onnxruntime_MINIMAL_BUILD;NOT onnxruntime_ENABLE_PYTHON" OFF)
# Even when onnxruntime_DISABLE_ABSEIL is ON, ONNX Runtime still needs to link to abseil.
option(onnxruntime_DISABLE_ABSEIL "Do not use Abseil data structures in ONNX Runtime source code. Redefine Inlined containers to STD containers." OFF)

option(onnxruntime_EXTENDED_MINIMAL_BUILD "onnxruntime_MINIMAL_BUILD with support for execution providers that compile kernels." OFF)
option(onnxruntime_MINIMAL_BUILD_CUSTOM_OPS "Add custom operator kernels support to a minimal build." OFF)
option(onnxruntime_REDUCED_OPS_BUILD "Reduced set of kernels are registered in build via modification of the kernel registration source files." OFF)
option(onnxruntime_DISABLE_EXTERNAL_INITIALIZERS "Don't allow models to load external data" OFF)

#A special option just for debugging and sanitize check. Please do not enable in option in retail builds.
#The option has no effect on Windows.
option(onnxruntime_USE_VALGRIND "Build with valgrind hacks" OFF)

# A special build option only used for gathering code coverage info

=== js/node/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

project (onnxruntime-node)

set(CMAKE_CXX_STANDARD 17)

add_compile_definitions(NAPI_VERSION=${napi_build_version})
add_compile_definitions(ORT_API_MANUAL_INIT)

# dist variables
execute_process(COMMAND node -e "console.log(process.platform)"
                OUTPUT_VARIABLE node_platform OUTPUT_STRIP_TRAILING_WHITESPACE)
file(READ ${CMAKE_SOURCE_DIR}/../../VERSION_NUMBER ort_version)
string(STRIP "${ort_version}" ort_version)
set(dist_folder "${CMAKE_SOURCE_DIR}/bin/napi-v6/${node_platform}/${NODE_ARCH}/")

# onnxruntime.dll dir
if(NOT ONNXRUNTIME_BUILD_DIR)
  if (WIN32)
    set(ONNXRUNTIME_BUILD_DIR ${CMAKE_SOURCE_DIR}/../../build/Windows/${CMAKE_BUILD_TYPE})
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(ONNXRUNTIME_BUILD_DIR ${CMAKE_SOURCE_DIR}/../../build/MacOS/${CMAKE_BUILD_TYPE})
  else()
    set(ONNXRUNTIME_BUILD_DIR ${CMAKE_SOURCE_DIR}/../../build/Linux/${CMAKE_BUILD_TYPE})
  endif()
endif()

# include dirs
include_directories(${CMAKE_JS_INC})
include_directories(${CMAKE_SOURCE_DIR}/../../include/onnxruntime/core/session)
include_directories(${CMAKE_SOURCE_DIR}/../../include/onnxruntime)
include_directories(${CMAKE_SOURCE_DIR}/../../onnxruntime)
include_directories(${CMAKE_SOURCE_DIR}/node_modules/node-addon-api)

# optional providers
option(USE_DML "Build with DirectML support" OFF)
option(USE_WEBGPU "Build with WebGPU support" OFF)
option(USE_CUDA "Build with CUDA support" OFF)
option(USE_TENSORRT "Build with TensorRT support" OFF)
option(USE_COREML "Build with CoreML support" OFF)
option(USE_QNN "Build with QNN support" OFF)

if(USE_DML)
  add_compile_definitions(USE_DML=1)
endif()
if(USE_WEBGPU)
  add_compile_definitions(USE_WEBGPU=1)
endif()
if(USE_CUDA)
  add_compile_definitions(USE_CUDA=1)
endif()
if(USE_TENSORRT)
  add_compile_definitions(USE_TENSORRT=1)
endif()
if(USE_COREML)
  add_compile_definitions(USE_COREML=1)
endif()
if(USE_QNN)
  add_compile_definitions(USE_QNN=1)
endif()

# source files
file(GLOB ORT_NODEJS_BINDING_SOURCE_FILES ${CMAKE_SOURCE_DIR}/src/*.cc)

add_library(onnxruntime_binding SHARED ${ORT_NODEJS_BINDING_SOURCE_FILES} ${CMAKE_JS_SRC})
file(MAKE_DIRECTORY ${dist_folder})

set_target_properties(onnxruntime_binding PROPERTIES
  PREFIX "" SUFFIX ".node"
  RUNTIME_OUTPUT_DIRECTORY ${dist_folder}
  RUNTIME_OUTPUT_DIRECTORY_DEBUG ${dist_folder}
  RUNTIME_OUTPUT_DIRECTORY_RELEASE ${dist_folder}
  RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${dist_folder}
  LIBRARY_OUTPUT_DIRECTORY ${dist_folder}
  LIBRARY_OUTPUT_DIRECTORY_DEBUG ${dist_folder}
  LIBRARY_OUTPUT_DIRECTORY_RELEASE ${dist_folder}
  LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO ${dist_folder}
  BUILD_WITH_INSTALL_RPATH TRUE
  INSTALL_RPATH_USE_LINK_PATH FALSE)
target_link_libraries(onnxruntime_binding PRIVATE ${CMAKE_JS_LIB})

if(MSVC AND CMAKE_JS_NODELIB_DEF AND CMAKE_JS_NODELIB_TARGET)
  # Generate node.lib
  execute_process(COMMAND ${CMAKE_AR} /def:${CMAKE_JS_NODELIB_DEF} /out:${CMAKE_JS_NODELIB_TARGET} ${CMAKE_STATIC_LINKER_FLAGS})
endif()

if (WIN32)
  if (${ONNXRUNTIME_GENERATOR} MATCHES "Ninja")
    set(ONNXRUNTIME_WIN_BIN_DIR ${ONNXRUNTIME_BUILD_DIR})
  else()
    set(ONNXRUNTIME_WIN_BIN_DIR ${ONNXRUNTIME_BUILD_DIR}/${CMAKE_BUILD_TYPE})
  endif()
  message(STATUS "onnxruntime dist dir: ${ONNXRUNTIME_WIN_BIN_DIR}")
endif()

if (APPLE)
  if (${ONNXRUNTIME_GENERATOR} MATCHES "Xcode")
    set(ONNXRUNTIME_MAC_BIN_DIR ${ONNXRUNTIME_BUILD_DIR}/${CMAKE_BUILD_TYPE})
  else()
    set(ONNXRUNTIME_MAC_BIN_DIR ${ONNXRUNTIME_BUILD_DIR})
  endif()
  message(STATUS "onnxruntime dist dir: ${ONNXRUNTIME_MAC_BIN_DIR}")
endif()

# add libraries
if (WIN32)
  target_link_directories(onnxruntime_binding PRIVATE ${ONNXRUNTIME_WIN_BIN_DIR})
elseif (APPLE)
  target_link_directories(onnxruntime_binding PRIVATE ${ONNXRUNTIME_MAC_BIN_DIR})
else()
  target_link_directories(onnxruntime_binding PRIVATE ${ONNXRUNTIME_BUILD_DIR})
endif()

if (WIN32)
  target_link_libraries(onnxruntime_binding PRIVATE onnxruntime)
elseif (APPLE)
  target_link_libraries(onnxruntime_binding PRIVATE libonnxruntime.${ort_version}.dylib)
  set_target_properties(onnxruntime_binding PROPERTIES INSTALL_RPATH "@loader_path")
else()
  target_link_libraries(onnxruntime_binding PRIVATE onnxruntime)
  set_target_properties(onnxruntime_binding PROPERTIES INSTALL_RPATH "$ORIGIN/")
endif()


if (WIN32)
  file(COPY ${ONNXRUNTIME_WIN_BIN_DIR}/onnxruntime.dll
      DESTINATION ${dist_folder})
elseif (APPLE)
  file(COPY ${ONNXRUNTIME_MAC_BIN_DIR}/libonnxruntime.dylib
      DESTINATION ${dist_folder} FOLLOW_SYMLINK_CHAIN)
elseif (UNIX)
  file(COPY ${ONNXRUNTIME_BUILD_DIR}/libonnxruntime.so
      DESTINATION ${dist_folder} FOLLOW_SYMLINK_CHAIN)
else()
  message(FATAL_ERROR "Platform not supported.")
endif()

if (ORT_NODEJS_DLL_DEPS)
  foreach(dll ${ORT_NODEJS_DLL_DEPS})
    file(COPY ${dll} DESTINATION ${dist_folder})
  endforeach()
endif()

=== cmake/tensorboard/compat/proto/CMakeLists.txt ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.

FetchContent_Declare(
  tensorboard
  URL ${DEP_URL_tensorboard}
  URL_HASH SHA1=${DEP_SHA1_tensorboard}
)
FetchContent_MakeAvailable(tensorboard)

set(TENSORBOARD_ROOT ${tensorboard_SOURCE_DIR})

# tensorboard protos
file(GLOB_RECURSE tensorboard_proto_srcs CONFIGURE_DEPENDS
  "${TENSORBOARD_ROOT}/tensorboard/compat/proto/*.proto"
)

add_library(tensorboard STATIC ${tensorboard_proto_srcs})
onnxruntime_protobuf_generate(APPEND_PATH IMPORT_DIRS ${tensorboard_SOURCE_DIR} ${protobuf_SOURCE_DIR}/src TARGET tensorboard)
onnxruntime_add_include_to_target(tensorboard ${PROTOBUF_LIB})
target_include_directories(tensorboard PRIVATE ${PROJECT_BINARY_DIR})
add_dependencies(tensorboard ${onnxruntime_EXTERNAL_DEPENDENCIES})
if(WIN32)
  target_compile_options(tensorboard PRIVATE "/wd4100" "/wd4125" "/wd4127" "/wd4267" "/wd4456" "/wd4800" "/wd6011" "/wd6387" "/wd28182")
endif()

if (NOT onnxruntime_BUILD_SHARED_LIB)
  install(TARGETS tensorboard EXPORT ${PROJECT_NAME}Targets
  ARCHIVE  DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY  DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME  DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== onnxruntime/python/tools/transformers/requirements.txt ===
onnx >= 1.8
numpy >= 1.19.0
coloredlogs
psutil
py-cpuinfo
py3nvml
packaging
transformers >= 4.18.0
scipy
sentencepiece
pillow

# please follow https://pytorch.org/ to install PyTorch for your OS
torch >= 2.6.0

=== tools/ci_build/requirements/pybind/requirements.txt ===
setuptools
flatbuffers
wheel==0.45.1
pytest
numpy>=1.19.0
sympy>=1.10
packaging
cerberus
psutil
flatbuffers

=== tools/ci_build/github/linux/python/requirements.txt ===
numpy==2.2.6
mypy
pytest
setuptools>=68.2.2
wheel
onnx==1.18.0
protobuf==4.25.1
sympy==1.14
flatbuffers
psutil
onnxscript==0.5.3
onnx-ir==0.1.10
jinja2
markupsafe

=== tools/ci_build/github/windows/python/requirements.txt ===
numpy==2.2.6
mypy
pytest
setuptools>=68.2.2
wheel
onnx==1.18.0
protobuf==4.25.1
sympy==1.14
flatbuffers
psutil
onnxscript==0.5.3
onnx-ir==0.1.10
jinja2
markupsafe
semver
packaging
coloredlogs

=== onnxruntime/python/tools/transformers/models/llama/requirements.txt ===
onnxscript>=0.2.3
optimum>=1.14.1
optree
transformers==4.52.1
torch>=2.7.0
onnx==1.17.0
datasets>=2.8.0
protobuf==3.20.2
psutil

=== onnxruntime/python/tools/transformers/models/whisper/requirements.txt ===
torch>=2.7.0
transformers==4.52.3
openai-whisper==20240927
ffmpeg-python
datasets
soundfile
librosa
optimum
onnxruntime-extensions>=0.9.0
onnx
protobuf==3.20.2
numpy==1.23.3
psutil
py3nvml

=== tools/ci_build/github/linux/docker/scripts/requirements.txt ===
cerberus
numpy==2.2.6
mypy
pytest
setuptools==78.1.1
wheel==0.45.1
onnx==1.18.0
argparse
sympy==1.14
flatbuffers
protobuf==4.25.1
packaging
onnxscript==0.5.3
onnx-ir==0.1.10

=== onnxruntime/python/tools/transformers/models/stable_diffusion/requirements/requirements.txt ===
huggingface_hub==0.25.2
diffusers==0.28.0
transformers==4.50.0
numpy>=1.24.1
accelerate
onnx==1.17.0
coloredlogs
packaging
# Use newer version of protobuf might cause crash
protobuf==3.20.3
psutil
sympy
nvtx==0.2.5
torchvision==0.15.2
tensorrt==8.5.1.7
mediapipe
controlnet_aux==0.0.9
# The following are for SDXL
optimum==1.20.0
safetensors
invisible_watermark
opencv-python-headless

=== tools/ci_build/github/linux/docker/scripts/manylinux/requirements.txt ===
numpy==2.2.6
mypy
pytest
setuptools>=68.2.2
wheel
onnx==1.18.0
protobuf==4.25.1
sympy==1.14
flatbuffers
neural-compressor>=2.2.1
triton==3.2.0

=== debian/changelog ===
onnxruntime (1.23.2+dfsg-6) unstable; urgency=medium

  * Pass -Wno-error=unused-variable to avoid FTBFS on the amd64v3
    architecture variant. (LP: 2141490)

 -- Charles <charles05@canonical.com>  Wed, 11 Feb 2026 00:32:23 +0000

onnxruntime (1.23.2+dfsg-5) unstable; urgency=medium

  * Pass -Wno-error=array-bound to avoid FTBFS with newer GCC-15
    (Closes: #1127519)

 -- Dylan Aïssi <daissi@debian.org>  Tue, 10 Feb 2026 15:31:14 +0100

onnxruntime (1.23.2+dfsg-4) unstable; urgency=medium

  [ YOKOTA Hiroshi ]
  * Append options instead of replace it on i386 platform
  * Fix autopkgtest error on some specific arm64 platform

 -- Dylan Aïssi <daissi@debian.org>  Sat, 07 Feb 2026 22:59:08 +0100

onnxruntime (1.23.2+dfsg-3) unstable; urgency=medium

  * Rewrite autopkgtests replacing PyTorch by NumPy + ONNX due to #1126427
      (Closes: #1126582)

 -- Dylan Aïssi <daissi@debian.org>  Thu, 29 Jan 2026 09:29:58 +0100

onnxruntime (1.23.2+dfsg-2) unstable; urgency=medium

  * Upload to unstable
  * gbp.conf: set debian/unstable

 -- Dylan Aïssi <daissi@debian.org>  Fri, 16 Jan 2026 09:53:24 +0100

onnxruntime (1.23.2+dfsg-1) experimental; urgency=medium

  * New upstream version 1.23.2+dfsg

 -- Dylan Aïssi <daissi@debian.org>  Tue, 13 Jan 2026 09:12:34 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

export DEB_CFLAGS_MAINT_STRIP=-O2
export DEB_CXXFLAGS_MAINT_STRIP=-O2
export DEB_CFLAGS_MAINT_APPEND+=-O3
export DEB_CXXFLAGS_MAINT_APPEND+=-O3


ifeq ($(DEB_HOST_ARCH),i386)
  export DEB_CFLAGS_MAINT_APPEND   += -msse2
  export DEB_CXXFLAGS_MAINT_APPEND += -msse2
endif

# https://github.com/microsoft/onnxruntime/issues/25681
export DEB_CFLAGS_MAINT_APPEND   += -Wno-error=uninitialized -Wno-error=array-bounds -Wno-error=unused-variable
export DEB_CXXFLAGS_MAINT_APPEND += -Wno-error=uninitialized -Wno-error=array-bounds -Wno-error=unused-variable

FULLVERSION=1.23.1
SOVERSION=1.23

# xnnpack is only available on several architectures.
# on riscv64 the provider is not usable: https://ci.debian.net/packages/o/onnxruntime/testing/riscv64/57967709/
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 x32))
USE_XNNPACK=ON
else
USE_XNNPACK=OFF
endif

# dnnl is only available on several architectures.
# riscv64 is temporarily disabled until onednn has openmp support on it,
# because onnxruntime always sets DNNL_OPENMP when onnxruntime_USE_DNNL is set.
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 ppc64el s390x))
USE_DNNL=ON
else
USE_DNNL=OFF
endif

PYVERS=$(shell python3 -c 'import sysconfig;print (sysconfig.get_python_version())')

PATH_LIB=usr/lib/${DEB_HOST_MULTIARCH}
PATH_LIB_PYTHON=usr/lib/python3/dist-packages/onnxruntime/capi

%:
	dh $@ --buildsystem=cmake+ninja --sourcedirectory=cmake --builddirectory=.

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_INSTALL_INCLUDEDIR=include \
		-Deigen_SOURCE_PATH=/usr/include/eigen3 \
		-Donnxruntime_BUILD_BENCHMARKS=OFF \
		-Donnxruntime_BUILD_SHARED_LIB=ON \
		-Donnxruntime_BUILD_UNIT_TESTS=OFF \
		-Donnxruntime_DISABLE_ABSEIL=ON \
		-Donnxruntime_ENABLE_CPUINFO=ON \
		-Donnxruntime_ENABLE_DLPACK=ON \
		-Donnxruntime_ENABLE_PYTHON=ON \
		-Donnxruntime_ONNX_PROTO_DATA_DIR=/usr/lib/python3/dist-packages \
		-Donnxruntime_ONNX_TEST_DATA_DIR=/usr/share/libonnx-testdata/data \
		-Donnxruntime_USE_FULL_PROTOBUF=ON \
		-Donnxruntime_USE_PREINSTALLED_EIGEN=ON \
		-Donnxruntime_USE_XNNPACK=$(USE_XNNPACK) \
		-Donnxruntime_USE_DNNL=$(USE_DNNL) \
		-DPYTHON_VERSION=${PYVERS} \
		$(NULL)

override_dh_auto_build:
	dh_auto_build
	# Build Python bindings
	dh_auto_build --buildsystem=pybuild --sourcedirectory=.

override_dh_auto_install:
	dh_auto_install
	# Install Python bindings
	dh_auto_install --buildsystem=pybuild --sourcedirectory=.

execute_after_dh_link:
	# To avoid having large duplicated libraries
	dh_link -ppython3-onnxruntime \
	  ${PATH_LIB}/libonnxruntime.so.$(SOVERSION) ${PATH_LIB_PYTHON}/libonnxruntime.so.$(SOVERSION) \
	  ${PATH_LIB}/libonnxruntime.so.$(FULLVERSION) ${PATH_LIB_PYTHON}/libonnxruntime.so.$(FULLVERSION)

override_dh_python3:
	dh_python3
	# remove loadable plugins already installed in libonnxruntime-providers
	-find debian/python3-onnxruntime -type f -name 'libonnxruntime_providers_*.so*' -delete

override_dh_auto_test:
	# Do NOT run tests, they depend on *.onnx dataset with unclear license
	# See https://github.com/microsoft/onnxruntime/issues/8963

override_dh_auto_clean:

override_dh_makeshlibs:
	dh_makeshlibs \
		--exclude=/usr/lib/$(DEB_HOST_MULTIARCH)/libonnxruntime_providers_ \
		-- -c4

=== debian/tests/control ===
Tests: build
Depends: build-essential, pkgconf, libonnxruntime-dev
Restrictions: superficial

Test-Command: cd debian/tests/ && ./inference-step1.py && ./inference-step2.py
Depends: @, python3-numpy, python3-onnx,
Restrictions: allow-stderr
Architecture: amd64 arm64 ppc64el s390x riscv64
Features: test-name=test-inference-simple

Test-Command: cd debian/tests/ && ./providers-step1.py && ./providers-step2.py
Depends: @, python3-numpy, python3-onnx,
Restrictions: allow-stderr
Architecture: amd64 arm64 ppc64el s390x riscv64
Features: test-name=test-execution-providers

# this needs python3-onnxscript, which is net yet packaged.
#Test-Command: python3 transformer.py
#Depends: @, python3-torch, python3-numpy,
#Restrictions: allow-stderr
#Architecture: amd64 arm64 ppc64el s390x riscv64
#Features: test-name=test-inference-transformers

=== debian/watch ===
Version: 5

Template: Github
Owner: microsoft
Project: onnxruntime
Dversionmangle: s/\+dfsg//g
Repacksuffix: +dfsg
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/(?:[^/]+\-)?(?:[-_]?[Vv](\d[\-+\.:\~\da-zA-Z]*))
# We need a custom Matching-Pattern because of some weird tags
